
public class Fraction
{
    private int numerator;
    private int denominator;
    
    /**
     * @param n numerator
     * @param d denominator, must not be 0
     * @throws ZeroDenomException if denominator is 0
     * @throws NegativeDenomException if denominator is < 0
     */
    public Fraction(int n, int d) 
    throws ZeroDenomException, NegativeDenomException 
    //throws FractionException 
    {
        if (d == 0) {
            throw new ZeroDenomException();
        }
        if (d < 0) {
            throw new NegativeDenomException();
        }
        
        numerator = n;
        denominator = d;
    }
    
    public void setNumerator(int n) {
        numerator = n;
    }
    
    /**
     * 
     * @param d denominator, must not be 0
     */
    public boolean setDenominator(int d) {
        //assert d != 0;
        if (d == 0) {
            return false;
        }
        denominator = d;
        return true;
    }
    
    public double toDouble() {
        assert denominator != 0;
        
        //return new Double(numerator) / denominator;
        //return (1.0 * numerator) / denominator;
        return ((double) numerator) / denominator;
        
        //return numerator / denominator;
    }
    
    /**
     * @param fr fraction
     * @throws NullPointerException if fr is null
     */
    public void copy(Fraction fr) {
        //if (fr == null) {
        //    throw new NullPointerException();
        //}
        numerator = fr.numerator;
        denominator = fr.denominator;
    }
}
